diff --git a/cdist/conf/type/__postgres_extension/explorer/state b/cdist/conf/type/__postgres_extension/explorer/state
new file mode 100644
index 00000000..9d156be7
--- /dev/null
+++ b/cdist/conf/type/__postgres_extension/explorer/state
@@ -0,0 +1,41 @@
+#!/bin/sh -e
+# -*- mode: sh; indent-tabs-mode: t -*-
+#
+# 2021 Dennis Camera (dennis.camera at ssrq-sds-fds.ch)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+# Prints "present" if the extension is currently installed.
+# "absent" otherwise.
+
+quote() { printf '%s\n' "$*" | sed "s/'/'\\\\''/g;1s/^/'/;\$s/\$/'/"; }
+
+postgres_user=$("${__type_explorer:?}/postgres_user")
+
+IFS=: read -r dbname extname <&2
+ exit 1
+ ;;
esac
diff --git a/cdist/conf/type/__postgres_extension/man.rst b/cdist/conf/type/__postgres_extension/man.rst
index 79645b2b..442239f6 100644
--- a/cdist/conf/type/__postgres_extension/man.rst
+++ b/cdist/conf/type/__postgres_extension/man.rst
@@ -3,32 +3,36 @@ cdist-type__postgres_extension(7)
NAME
----
-cdist-type__postgres_extension - manage postgres extensions
+cdist-type__postgres_extension - Manage PostgreSQL extensions
DESCRIPTION
-----------
-This cdist type allows you to create or drop postgres extensions.
+This cdist type allows you to manage PostgreSQL extensions.
-The object you need to pass to __postgres_extension consists of
-the database name and the extension name joined by a colon in the
-following form:
-
-.. code-block:: sh
-
- dbname:extension
-
-f.ex.
+The ``__object_id`` to pass to ``__postgres_extension`` is of the form
+``dbname:extension``, e.g.:
.. code-block:: sh
rails_test:unaccent
+**CAUTION!** Be careful when installing extensions from (untrusted) third-party
+sources:
+
+ | Installing an extension as superuser requires trusting that the extension's
+ author wrote the extension installation script in a secure fashion. It is
+ not terribly difficult for a malicious user to create trojan-horse objects
+ that will compromise later execution of a carelessly-written extension
+ script, allowing that user to acquire superuser privileges.
+ | – ``_
+
+
OPTIONAL PARAMETERS
-------------------
state
- either "present" or "absent", defaults to "present"
+ either ``present`` or ``absent``, defaults to ``present``.
EXAMPLES
@@ -36,24 +40,29 @@ EXAMPLES
.. code-block:: sh
- __postgres_extension rails_test:unaccent
- __postgres_extension --present rails_test:unaccent
- __postgres_extension --absent rails_test:unaccent
+ # Install extension unaccent into database rails_test
+ __postgres_extension rails_test:unaccent
+
+ # Drop extension unaccent from database fails_test
+ __postgres_extension rails_test:unaccent --state absent
SEE ALSO
--------
-:strong:`cdist-type__postgre_database`\ (7)
+- :strong:`cdist-type__postgres_database`\ (7)
+- PostgreSQL "CREATE EXTENSION" documentation at:
+ ``_.
-Postgres "Create Extension" documentation at: .
-AUTHOR
+AUTHORS
-------
-Tomas Pospisek
+| Tomas Pospisek
+| Dennis Camera
+
COPYING
-------
-Copyright \(C) 2014 Tomas Pospisek. You can redistribute it
-and/or modify it under the terms of the GNU General Public License as
-published by the Free Software Foundation, either version 3 of the
-License, or (at your option) any later version.
+Copyright \(C) 2014 Tomas Pospisek, 2021 Dennis Camera.
+You can redistribute it and/or modify it under the terms of the GNU General
+Public License as published by the Free Software Foundation, either version 3 of
+the License, or (at your option) any later version.